'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

var _baseClassName = require('./baseClassName');

var _baseClassName2 = _interopRequireDefault(_baseClassName);

var _propTypes3 = require('./propTypes');

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Modal.__proto__ || Object.getPrototypeOf(Modal)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      afterOpen: false,
      waitingClose: false
    }, _this.close = function () {
      _this.setState({
        waitingClose: false,
        isOpen: false,
        afterOpen: false,
        closeTimestamp: null
      });
    }, _this.refNode = function (node) {
      _this.node = node;

      var ref = _this.props.ref;


      if (ref) {
        ref(node);
      }
    }, _this.refOverlay = function (overlay) {
      _this.overlay = overlay;

      var overlayRef = _this.props.overlayRef;


      if (overlayRef) {
        overlayRef(overlay);
      }
    }, _this.refContent = function (content) {
      _this.content = content;

      var contentRef = _this.props.contentRef;


      if (contentRef) {
        contentRef(content);
      }
    }, _this.handleOnCloseClick = function () {
      if (_this.props.onClose) {
        _this.props.onClose();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Modal, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.notifyModalStack();

      if (this.props.open) {
        this.requestOpen();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!this.props.open && nextProps.open) {
        this.requestOpen();
      } else if (this.props.open && !nextProps.open) {
        this.requestClose();
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.notifyModalStack();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.notifyModalStack();
    }
  }, {
    key: 'notifyModalStack',
    value: function notifyModalStack() {
      this.context.modalStack.update();
    }
  }, {
    key: 'getClassName',
    value: function getClassName(classNameProp) {
      var className = this.props[classNameProp];
      var isRedefined = (typeof className === 'undefined' ? 'undefined' : _typeof(className)) === 'object';

      var _ref2 = isRedefined ? className : Modal.classNames[classNameProp],
          base = _ref2.base,
          onAfterOpen = _ref2.onAfterOpen,
          onBeforeClose = _ref2.onBeforeClose;

      var classNames = [base];

      if (onAfterOpen && this.state.afterOpen) {
        classNames.push(onAfterOpen);
      }
      if (onBeforeClose && this.state.waitingClose) {
        classNames.push(onBeforeClose);
      }
      if (!isRedefined) {
        classNames.push(className);
      }

      return classNames.join(' ');
    }
  }, {
    key: 'requestOpen',
    value: function requestOpen() {
      var _state = this.state,
          afterOpen = _state.afterOpen,
          waitingClose = _state.waitingClose;


      if (afterOpen && waitingClose) {
        clearTimeout(this.closeTimeout);
        this.setState({ waitingClose: false });
      } else {
        this.open();
      }
    }
  }, {
    key: 'open',
    value: function open() {
      var _this2 = this;

      this.setState({ isOpen: true }, function () {
        // FIXME
        setTimeout(function () {
          _this2.setState({ afterOpen: true });
        });
      });
    }
  }, {
    key: 'requestClose',
    value: function requestClose() {
      var _this3 = this;

      var closeTimeout = this.props.closeTimeout;


      if (closeTimeout > 0) {
        var closeTimestamp = (0, _helpers.msToTimestamp)(closeTimeout);

        this.setState({ waitingClose: true, closeTimestamp: closeTimestamp }, function () {
          _this3.closeTimeout = setTimeout(_this3.close, (0, _helpers.timeStampToMs)(_this3.state.closeTimestamp));
        });
      } else {
        this.close();
      }
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren() {
      var children = this.props.children;


      var renderedChildren = typeof children === 'function' ? children({
        close: this.handleOnCloseClick
      }) : children;

      if (!renderedChildren) {
        return null;
      }

      return _react2.default.Children.only(renderedChildren);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          closeOnEsc = _props.closeOnEsc,
          _props$styles = _props.styles,
          contentStyles = _props$styles.content,
          overlayStyles = _props$styles.overlay,
          closeOnOverlayClick = _props.closeOnOverlayClick;


      if (!this.state.isOpen) {
        return null;
      }

      return _reactDom2.default.createPortal(_react2.default.createElement(
        'div',
        { className: this.getClassName('className'), ref: this.refNode },
        _react2.default.createElement(_Overlay2.default, {
          className: this.getClassName('overlayClassName'),
          style: overlayStyles,
          onClick: closeOnOverlayClick && this.handleOnCloseClick,
          ref: this.refOverlay
        }),
        _react2.default.createElement(
          _Content2.default,
          {
            className: this.getClassName('contentClassName'),
            style: contentStyles,
            closeOnEsc: closeOnEsc,
            onRequestClose: this.handleOnCloseClick,
            ref: this.refContent
          },
          this.renderChildren()
        )
      ), this.context.modalStack.rootNode);
    }
  }]);

  return Modal;
}(_react2.default.Component);

Modal.classNames = {
  className: {
    base: _baseClassName2.default + '__Modal',
    onAfterOpen: _baseClassName2.default + '__Modal--on-after-open',
    onBeforeClose: _baseClassName2.default + '__Modal--on-before-close'
  },
  overlayClassName: {
    base: _baseClassName2.default + '__Overlay',
    onAfterOpen: _baseClassName2.default + '__Overlay--on-after-open',
    onBeforeClose: _baseClassName2.default + '__Overlay--on-before-close'
  },
  contentClassName: {
    base: _baseClassName2.default + '__Content',
    onAfterOpen: _baseClassName2.default + '__Content--on-after-open',
    onBeforeClose: _baseClassName2.default + '__Content--on-before-close'
  }
};
Modal.contextTypes = {
  modalStack: _propTypes2.default.shape({
    rootNode: _propTypes2.default.instanceOf(Element).isRequired,
    update: _propTypes2.default.func.isRequired
  }).isRequired
};
Modal.defaultProps = {
  styles: {},
  open: false,
  closeOnEsc: false,
  closeOnOverlayClick: true,
  closeTimeout: 0
};
Modal.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  className: _propTypes3.classNamePropType,
  overlayClassName: _propTypes3.classNamePropType,
  contentClassName: _propTypes3.classNamePropType,
  ref: _propTypes2.default.func,
  overlayRef: _propTypes2.default.func,
  contentRef: _propTypes2.default.func,
  styles: _propTypes2.default.shape({
    overlay: _propTypes2.default.object,
    content: _propTypes2.default.object
  }),
  open: _propTypes2.default.bool,
  closeOnEsc: _propTypes2.default.bool,
  closeOnOverlayClick: _propTypes2.default.bool,
  onClose: _propTypes2.default.func,
  closeTimeout: _propTypes2.default.number
};
exports.default = Modal;