'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _baseClassName = require('./baseClassName');

var _baseClassName2 = _interopRequireDefault(_baseClassName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ModalStack = function (_React$Component) {
  _inherits(ModalStack, _React$Component);

  _createClass(ModalStack, [{
    key: 'portalNode',
    get: function get() {
      return this._portalNode;
    },
    set: function set(node) {
      this._portalNode = node;
    }
  }, {
    key: 'mountNode',
    get: function get() {
      var rootNode = this.props.rootNode;


      if (this._mountNode) {
        return this._mountNode;
      }

      if (typeof rootNode === 'string') {
        this._mountNode = document.querySelector(rootNode);
      } else if (rootNode) {
        this._mountNode = rootNode;
      }

      return this._mountNode;
    }
  }]);

  function ModalStack(props) {
    _classCallCheck(this, ModalStack);

    var _this = _possibleConstructorReturn(this, (ModalStack.__proto__ || Object.getPrototypeOf(ModalStack)).call(this, props));

    _this.handleUpdate = function () {
      var hasMountedModals = _this.portalNode.hasChildNodes();

      if (_this.props.unmountWhenEmpty) {
        if (hasMountedModals) {
          _this.mount();
        } else {
          _this.unmount();
        }
      }

      document.body.classList.toggle(_baseClassName2.default + '__Body--opened', hasMountedModals);
    };

    _this.createPortalNode();
    return _this;
  }

  _createClass(ModalStack, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      (0, _warning2.default)(this.props.unmountWhenEmpty === nextProps.unmountWhenEmpty, 'You cannot change "unmountWhenEmpty"');
      (0, _warning2.default)(this.props.rootNode === nextProps.rootNode, 'You cannot change "rootNode"');
    }
  }, {
    key: 'createPortalNode',
    value: function createPortalNode() {
      var node = document.createElement('div');
      node.classList.add(_baseClassName2.default + '__Portal');

      this.portalNode = node;
    }
  }, {
    key: 'mount',
    value: function mount() {
      if (this.portalNode.parentNode === this.mountNode) {
        return;
      }

      this.mountNode.appendChild(this.portalNode);
    }
  }, {
    key: 'unmount',
    value: function unmount() {
      if (this.portalNode.parentNode !== this.mountNode) {
        return;
      }

      this.mountNode.removeChild(this.portalNode);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (!this.props.unmountWhenEmpty) {
        this.mount();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unmount();
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        modalStack: {
          rootNode: this.portalNode,
          update: this.handleUpdate,
          subscribe: this.handleSubscribe
        }
      };
    }
  }]);

  return ModalStack;
}(_react2.default.Component);

ModalStack.propTypes = {
  children: _propTypes2.default.node,
  rootNode: _propTypes2.default.oneOfType([_propTypes2.default.instanceOf(Element), _propTypes2.default.string]),
  unmountWhenEmpty: _propTypes2.default.bool
};
ModalStack.defaultProps = {
  rootNode: document.body,
  unmountWhenEmpty: false
};
ModalStack.childContextTypes = {
  modalStack: _propTypes2.default.shape({
    rootNode: _propTypes2.default.instanceOf(Element)
  })
};
exports.default = ModalStack;