import React from 'react'
import PropTypes from 'prop-types'

class Overlay extends React.Component {
  static defaultStyles = {
    position: 'fixed',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    backgroundColor: 'rgba(0, 0, 0, 0.75)'
  }

  static propTypes = {
    children: PropTypes.node,
    style: PropTypes.object,
    className: PropTypes.string,
    onClick: PropTypes.func
  }

  get style() {
    const defaultStyles = Overlay.defaultStyles
    const styles = this.props.style

    if (!styles) {
      return defaultStyles
    }

    return Object.assign({}, defaultStyles, styles)
  }

  render() {
    const { className, children, onClick } = this.props

    return (
      <div className={className} style={this.style} onClick={onClick}>
        {children}
      </div>
    )
  }
}

export default Overlay
