import React from 'react'
import { mount } from 'enzyme'
import { Modal } from '../src'

const mountModal = props => {
  return mount(<Modal {...props} />, {
    context: {
      modalStack: {
        rootNode: document.body,
        update: () => {}
      }
    }
  })
}

describe('Modal', () => {
  it('can be open initially', () => {
    const modal = mountModal({
      open: true
    })

    expect(modal.children().length).not.toBe(0)
  })

  it('can be closed initially', () => {
    const modal = mountModal()

    expect(modal.children().length).toBe(0)
  })
})
